searchNodes=[{"doc":"Provides a suit of html custom component for phoenix. This library provides three main functionalities: Enhance form helper with manterial web componet Enhance link helper with manterial web componet Markdown render helper with @gsmlg/lit/remark-element Form helper See Phoenix.WebComponent.FormHelper . JavaScript library This project provides javascript that define custom elements. To use the web component, you must load priv/static/phoenix_webcomponent.js into your build tool. Or through npm by install phoenix_webcomponent . The difference is npm version is not bundled.","ref":"Phoenix.WebComponent.html","title":"Phoenix.WebComponent","type":"module"},{"doc":"Returns a list of attributes that make an element behave like a link. For example, to make a button work like a link: &lt; button { link_attributes ( &quot;/home&quot; ) } &gt; Go back to home &lt; / button &gt; However, this function is more often used to create buttons that must invoke an action on the server, such as deleting an entity, using the relevant HTTP protocol: &lt; button data - confirm = &quot;Are you sure?&quot; { link_attributes ( &quot;/product/1&quot; , method : :delete } &gt; Delete product &lt; / button &gt; The to argument may be a string, a URI, or a tuple {scheme, value} . See the examples below. Note: using this function requires loading the JavaScript library at priv/static/phoenix_html.js . See the Phoenix.HTML module documentation for more information. Options :method - the HTTP method for the link. Defaults to :get . :csrf_token - a custom token to use when method is not :get . This is used to ensure the request was sent by the user who rendered the page. By default, CSRF tokens are generated through Plug.CSRFProtection . You can set this option to false , to disable token generation, or set it to your own token. When the :method is set to :get and the :to URL contains query parameters the generated form element will strip the parameters in accordance with the W3C form specification. Data attributes The following data attributes can also be manually set in the element: data-confirm - shows a confirmation prompt before generating and submitting the form. Examples iex&gt; link_attributes(&quot;/world&quot;) [data: [method: :get, to: &quot;/world&quot;]] iex&gt; link_attributes(URI.parse(&quot; https://elixir-lang.org&quot; )) [data: [method: :get, to: &quot; https://elixir-lang.org&quot;]] iex&gt; link_attributes(&quot;/product/1&quot;, method: :delete) [data: [csrf: Plug.CSRFProtection.get_csrf_token(), method: :delete, to: &quot;/product/1&quot;]] If the URL is absolute, only certain schemas are allowed to avoid JavaScript injection. For example, the following will fail iex&gt; link_attributes(&quot;javascript:alert('hacked!')&quot;) ** (ArgumentError) unsupported scheme given as link. In case you want to link to an unknown or unsafe scheme, such as javascript, use a tuple: {:javascript, rest} You can however explicitly render those unsafe schemes by using a tuple: iex&gt; link_attributes({:javascript, &quot;alert('my alert!')&quot;}) [data: [method: :get, to: [&quot;javascript&quot;, 58, &quot;alert('my alert!')&quot;]]]","ref":"Phoenix.WebComponent.html#link_attributes/2","title":"Phoenix.WebComponent.link_attributes/2","type":"function"},{"doc":"Helpers related to producing HTML forms. The functions in this module can be used in three distinct scenarios: with changeset data - when information to populate the form comes from a changeset with limited data - when a form is created without an underlying data layer. In this scenario, you can use the connection information (aka Plug.Conn.params) or pass the form values by hand outside of a form - when the functions are used directly, outside of form_for We will explore all three scenarios below. With changeset data The entry point for defining forms in Phoenix is with the form_for/4 function. For this example, we will use Ecto.Changeset , which integrates nicely with Phoenix forms via the phoenix_ecto package. Imagine you have the following action in your controller: def new ( conn , _params ) do changeset = User . changeset ( % User { } ) render conn , &quot;new.html&quot; , changeset : changeset end where User.changeset/2 is defined as follows: def changeset ( user , params \\\\ %{ } ) do Ecto.Changeset . cast ( user , params , [ :name , :age ] ) end Now a @changeset assign is available in views which we can pass to the form: &lt; % = form_for @changeset , Routes . user_path ( @conn , :create ) , fn f -&gt; % &gt; &lt; label &gt; &lt; % = wc_text_input f , :name % &gt; &lt; / label &gt; &lt; label &gt; &lt; % = wc_select f , :age , 18 .. 100 % &gt; &lt; / label &gt; &lt; % = wc_submit &quot;Submit&quot; % &gt; &lt; % end % &gt; form_for/4 receives the Ecto.Changeset and converts it to a form, which is passed to the function as the argument f . All the remaining functions in this module receive the form and automatically generate the input fields, often by extracting information from the given changeset. For example, if the user had a default value for age set, it will automatically show up as selected in the form. A note on :errors If no action has been applied to the changeset or action was set to :ignore , no errors are shown on the form object even if the changeset has a non-empty :errors value. This is useful for things like validation hints on form fields, e.g. an empty changeset for a new form. That changeset isn't valid, but we don't want to show errors until an actual user action has been performed. Ecto automatically applies the action for you when you call Repo.insert/update/delete, but if you want to show errors manually you can also set the action yourself, either directly on the Ecto.Changeset struct field or by using Ecto.Changeset.apply_action/2 . With limited data form_for/4 expects as first argument any data structure that implements the Phoenix.WebComponent.FormData protocol. By default, Phoenix implements this protocol for Plug.Conn and Atom . This is useful when you are creating forms that are not backed by any kind of data layer. Let's assume that we're submitting a form to the :new action in the FooController : &lt; % = form_for @conn , Routes . foo_path ( @conn , :new ) , [ as : :foo ] , fn f -&gt; % &gt; &lt; % = wc_text_input f , :for % &gt; &lt; % = wc_submit &quot;Search&quot; % &gt; &lt; % end % &gt; form_for/4 uses the Plug.Conn to set input values from the request parameters. Alternatively, if you don't have a connection, you can pass :foo as the form data source and explicitly pass the value for every input: &lt; % = form_for :foo , Routes . foo_path ( MyApp.Endpoint , :new ) , fn f -&gt; % &gt; &lt; % = wc_text_input f , :for , value : &quot;current value&quot; % &gt; &lt; % = wc_submit &quot;Search&quot; % &gt; &lt; % end % &gt; Without form data Sometimes we may want to generate a text_input/3 or any other tag outside of a form. The functions in this module also support such usage by simply passing an atom as first argument instead of the form. &lt; % = wc_text_input :user , :name , value : &quot;This is a prepopulated value&quot; % &gt;","ref":"Phoenix.WebComponent.FormHelper.html","title":"Phoenix.WebComponent.FormHelper","type":"module"},{"doc":"Returns options to be used inside a select. This is useful when building the select by hand. It expects all options and one or more select values. Examples options_for_select ( [ &quot;Admin&quot; : &quot;admin&quot; , &quot;User&quot; : &quot;user&quot; ] , &quot;admin&quot; ) #=&gt; &lt;option value=&quot;admin&quot; selected=&quot;selected&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;user&quot;&gt;User&lt;/option&gt; Groups are also supported: options_for_select ( [ &quot;Europe&quot; : [ &quot;UK&quot; , &quot;Sweden&quot; , &quot;France&quot; ] , ... ] , nil ) #=&gt; &lt;optgroup label=&quot;Europe&quot;&gt; #=&gt; &lt;option&gt;UK&lt;/option&gt; #=&gt; &lt;option&gt;Sweden&lt;/option&gt; #=&gt; &lt;option&gt;France&lt;/option&gt; #=&gt; &lt;/optgroup&gt;","ref":"Phoenix.WebComponent.FormHelper.html#options_for_select/2","title":"Phoenix.WebComponent.FormHelper.options_for_select/2","type":"function"},{"doc":"Generates a wc_checkbox. This function is useful for sending boolean values to the server. Examples # Assuming form contains a User schema wc_checkbox ( form , :famous ) #=&gt; &lt;input name=&quot;user[famous]&quot; type=&quot;hidden&quot; value=&quot;false&quot;&gt; #=&gt; &lt;input checked=&quot;checked&quot; id=&quot;user_famous&quot; name=&quot;user[famous]&quot; type=&quot;wc_checkbox&quot; value=&quot;true&quot;&gt; Options :checked_value - the value to be sent when the wc_checkbox is checked. Defaults to &quot;true&quot; :hidden_input - controls if this function will generate a hidden input to wc_submit the unchecked value or not. Defaults to &quot;true&quot; :unchecked_value - the value to be sent when the wc_checkbox is unchecked, Defaults to &quot;false&quot; :value - the value used to check if a wc_checkbox is checked or unchecked. The default value is extracted from the form data if available All other options are forwarded to the underlying HTML tag. Hidden fields Because an unchecked wc_checkbox is not sent to the server, Phoenix automatically generates a hidden field with the unchecked_value before the wc_checkbox field to ensure the unchecked_value is sent when the wc_checkbox is not marked. Set hidden_input to false If you don't want to send values from unchecked wc_checkbox to the server.","ref":"Phoenix.WebComponent.FormHelper.html#wc_checkbox/3","title":"Phoenix.WebComponent.FormHelper.wc_checkbox/3","type":"function"},{"doc":"Generates a color input. Warning: this feature isn't available in all browsers. Check http://caniuse.com/#feat=input-color for further information. See text_input/3 for example and docs.","ref":"Phoenix.WebComponent.FormHelper.html#wc_color_input/3","title":"Phoenix.WebComponent.FormHelper.wc_color_input/3","type":"function"},{"doc":"Generates a date input. Warning: this feature isn't available in all browsers. Check http://caniuse.com/#feat=input-datetime for further information. See text_input/3 for example and docs.","ref":"Phoenix.WebComponent.FormHelper.html#wc_date_input/3","title":"Phoenix.WebComponent.FormHelper.wc_date_input/3","type":"function"},{"doc":"Generates select tags for date. Check wc_datetime_select/3 for more information on options and supported values.","ref":"Phoenix.WebComponent.FormHelper.html#wc_date_select/3","title":"Phoenix.WebComponent.FormHelper.wc_date_select/3","type":"function"},{"doc":"Generates a datetime-local input. Warning: this feature isn't available in all browsers. Check http://caniuse.com/#feat=input-datetime for further information. See text_input/3 for example and docs.","ref":"Phoenix.WebComponent.FormHelper.html#wc_datetime_local_input/3","title":"Phoenix.WebComponent.FormHelper.wc_datetime_local_input/3","type":"function"},{"doc":"Generates select tags for datetime. Examples # Assuming form contains a User schema wc_datetime_select form , :born_at #=&gt; &lt;select id=&quot;user_born_at_year&quot; name=&quot;user[born_at][year]&quot;&gt;...&lt;/select&gt; / #=&gt; &lt;select id=&quot;user_born_at_month&quot; name=&quot;user[born_at][month]&quot;&gt;...&lt;/select&gt; / #=&gt; &lt;select id=&quot;user_born_at_day&quot; name=&quot;user[born_at][day]&quot;&gt;...&lt;/select&gt; — #=&gt; &lt;select id=&quot;user_born_at_hour&quot; name=&quot;user[born_at][hour]&quot;&gt;...&lt;/select&gt; : #=&gt; &lt;select id=&quot;user_born_at_min&quot; name=&quot;user[born_at][minute]&quot;&gt;...&lt;/select&gt; If you want to include the seconds field (hidden by default), pass second: [] : # Assuming form contains a User schema wc_datetime_select form , :born_at , second : [ ] If you want to configure the years range: # Assuming form contains a User schema wc_datetime_select form , :born_at , year : [ options : 1900 .. 2100 ] You are also able to configure :month , :day , :hour , :minute and :second . All options given to those keys will be forwarded to the underlying select. See select/4 for more information. For example, if you are using Phoenix with Gettext and you want to localize the list of months, you can pass :options to the :month key: # Assuming form contains a User schema wc_datetime_select form , :born_at , month : [ options : [ { gettext ( &quot;January&quot; ) , &quot;1&quot; } , { gettext ( &quot;February&quot; ) , &quot;2&quot; } , { gettext ( &quot;March&quot; ) , &quot;3&quot; } , { gettext ( &quot;April&quot; ) , &quot;4&quot; } , { gettext ( &quot;May&quot; ) , &quot;5&quot; } , { gettext ( &quot;June&quot; ) , &quot;6&quot; } , { gettext ( &quot;July&quot; ) , &quot;7&quot; } , { gettext ( &quot;August&quot; ) , &quot;8&quot; } , { gettext ( &quot;September&quot; ) , &quot;9&quot; } , { gettext ( &quot;October&quot; ) , &quot;10&quot; } , { gettext ( &quot;November&quot; ) , &quot;11&quot; } , { gettext ( &quot;December&quot; ) , &quot;12&quot; } , ] ] You may even provide your own localized_wc_datetime_select/3 built on top of wc_datetime_select/3 : defp localized_wc_datetime_select ( form , field , opts \\\\ [ ] ) do opts = Keyword . put ( opts , :month , options : [ { gettext ( &quot;January&quot; ) , &quot;1&quot; } , { gettext ( &quot;February&quot; ) , &quot;2&quot; } , { gettext ( &quot;March&quot; ) , &quot;3&quot; } , { gettext ( &quot;April&quot; ) , &quot;4&quot; } , { gettext ( &quot;May&quot; ) , &quot;5&quot; } , { gettext ( &quot;June&quot; ) , &quot;6&quot; } , { gettext ( &quot;July&quot; ) , &quot;7&quot; } , { gettext ( &quot;August&quot; ) , &quot;8&quot; } , { gettext ( &quot;September&quot; ) , &quot;9&quot; } , { gettext ( &quot;October&quot; ) , &quot;10&quot; } , { gettext ( &quot;November&quot; ) , &quot;11&quot; } , { gettext ( &quot;December&quot; ) , &quot;12&quot; } , ] ) wc_datetime_select ( form , field , opts ) end Options :value - the value used to select a given option. The default value is extracted from the form data if available :default - the default value to use when none was given in :value and none is available in the form data :year , :month , :day , :hour , :minute , :second - options passed to the underlying select. See select/4 for more information. The available values can be given in :options . :builder - specify how the select can be build. It must be a function that receives a builder that should be invoked with the select name and a set of options. See builder below for more information. Builder The generated wc_datetime_select can be customized at will by providing a builder option. Here is an example from EEx: &lt; % = wc_datetime_select form , :born_at , builder : fn b -&gt; % &gt; Date : &lt; % = b . ( :day , [ ] ) % &gt; / &lt; % = b . ( :month , [ ] ) % &gt; / &lt; % = b . ( :year , [ ] ) % &gt; Time : &lt; % = b . ( :hour , [ ] ) % &gt; : &lt; % = b . ( :minute , [ ] ) % &gt; &lt; % end % &gt; Although we have passed empty lists as options (they are required), you could pass any option there and it would be given to the underlying select input. In practice, we recommend you to create your own helper with your default builder: def my_wc_datetime_select ( form , field , opts \\\\ [ ] ) do builder = fn b -&gt; assigns = %{ b : b } ~H&quot;&quot;&quot; Date: &lt;%= @b.(:day, []) %&gt; / &lt;%= @b.(:month, []) %&gt; / &lt;%= @b.(:year, []) %&gt; Time: &lt;%= @b.(:hour, []) %&gt; : &lt;%= @b.(:minute, []) %&gt; &quot;&quot;&quot; end wc_datetime_select ( form , field , [ builder : builder ] ++ opts ) end Then you are able to use your own wc_datetime_select throughout your whole application. Supported date values The following values are supported as date: a map containing the year , month and day keys (either as strings or atoms) a tuple with three elements: {year, month, day} a string in ISO 8601 format nil Supported time values The following values are supported as time: a map containing the hour and minute keys and an optional second key (either as strings or atoms) a tuple with three elements: {hour, min, sec} a tuple with four elements: {hour, min, sec, usec} nil","ref":"Phoenix.WebComponent.FormHelper.html#wc_datetime_select/3","title":"Phoenix.WebComponent.FormHelper.wc_datetime_select/3","type":"function"},{"doc":"Generates an email input. Auto add pattern=&quot;[^@]+@[^@]+&quot; to check format See text_input/3 for example and docs.","ref":"Phoenix.WebComponent.FormHelper.html#wc_email_input/3","title":"Phoenix.WebComponent.FormHelper.wc_email_input/3","type":"function"},{"doc":"Generates a file input. It requires the given form to be configured with multipart: true when invoking form_for/4 , otherwise it fails with ArgumentError . See wc_text_input/3 for example and docs.","ref":"Phoenix.WebComponent.FormHelper.html#wc_file_input/3","title":"Phoenix.WebComponent.FormHelper.wc_file_input/3","type":"function"},{"doc":"Generates a select tag with the given options . Values are expected to be an Enumerable containing two-item tuples (like maps and keyword lists) or any Enumerable where the element will be used both as key and value for the generated select. Examples # Assuming form contains a User schema wc_multiple_select ( form , :roles , [ &quot;Admin&quot; : 1 , &quot;Power User&quot; : 2 ] ) #=&gt; &lt;select id=&quot;user_roles&quot; name=&quot;user[roles][]&quot;&gt; #=&gt; &lt;option value=&quot;1&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;2&quot;&gt;Power User&lt;/option&gt; #=&gt; &lt;/select&gt; wc_multiple_select ( form , :roles , [ &quot;Admin&quot; : 1 , &quot;Power User&quot; : 2 ] , selected : [ 1 ] ) #=&gt; &lt;select id=&quot;user_roles&quot; name=&quot;user[roles][]&quot;&gt; #=&gt; &lt;option value=&quot;1&quot; selected=&quot;selected&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;2&quot;&gt;Power User&lt;/option&gt; #=&gt; &lt;/select&gt; When working with structs, associations and embeds, you will need to tell Phoenix how to extract the value out of the collection. For example, imagine user.roles is a list of %Role{} structs. You must call it as: wc_multiple_select ( form , :roles , [ &quot;Admin&quot; : 1 , &quot;Power User&quot; : 2 ] , selected : Enum . map ( @user . roles , &amp; ( &amp;1 . id ) ) The :selected option will mark the given IDs as selected unless the form is being resubmitted. When resubmitted, it uses the form params as values. Options :selected - the default options to be marked as selected. The values on this list are ignored in case ids have been set as parameters. All other options are forwarded to the underlying HTML tag.","ref":"Phoenix.WebComponent.FormHelper.html#wc_multiple_select/4","title":"Phoenix.WebComponent.FormHelper.wc_multiple_select/4","type":"function"},{"doc":"Generates a number input. See text_input/3 for example and docs.","ref":"Phoenix.WebComponent.FormHelper.html#wc_number_input/3","title":"Phoenix.WebComponent.FormHelper.wc_number_input/3","type":"function"},{"doc":"Generates a password input. For security reasons, the form data and parameter values are never re-used in password_input/3 . Pass the value explicitly if you would like to set one. See text_input/3 for example and docs.","ref":"Phoenix.WebComponent.FormHelper.html#wc_password_input/3","title":"Phoenix.WebComponent.FormHelper.wc_password_input/3","type":"function"},{"doc":"Generates a radio button. Invoke this function for each possible value you want to be sent to the server. Examples # Assuming form contains a User schema wc_radio_button ( form , :role , &quot;admin&quot; ) #=&gt; &lt;input id=&quot;user_role_admin&quot; name=&quot;user[role]&quot; type=&quot;radio&quot; value=&quot;admin&quot;&gt; Options All options are simply forwarded to the underlying HTML tag.","ref":"Phoenix.WebComponent.FormHelper.html#wc_radio_button/4","title":"Phoenix.WebComponent.FormHelper.wc_radio_button/4","type":"function"},{"doc":"Generates a range input. See text_input/3 for example and docs.","ref":"Phoenix.WebComponent.FormHelper.html#wc_range_input/3","title":"Phoenix.WebComponent.FormHelper.wc_range_input/3","type":"function"},{"doc":"Generates a reset input to reset all the form fields to their original state. All options are forwarded to the underlying input tag. Examples wc_reset &quot;Reset&quot; #=&gt; &lt;input type=&quot;reset&quot; value=&quot;Reset&quot;&gt; wc_reset &quot;Reset&quot; , class : &quot;btn&quot; #=&gt; &lt;input type=&quot;reset&quot; value=&quot;Reset&quot; class=&quot;btn&quot;&gt;","ref":"Phoenix.WebComponent.FormHelper.html#wc_reset/2","title":"Phoenix.WebComponent.FormHelper.wc_reset/2","type":"function"},{"doc":"Generates a search input. See text_input/3 for example and docs.","ref":"Phoenix.WebComponent.FormHelper.html#wc_search_input/3","title":"Phoenix.WebComponent.FormHelper.wc_search_input/3","type":"function"},{"doc":"Generates a select tag with the given options . options are expected to be an enumerable which will be used to generate each respective option . The enumerable may have: keyword lists - each keyword list is expected to have the keys :key and :value . Additional keys such as :disabled may be given to customize the option two-item tuples - where the first element is an atom, string or integer to be used as the option label and the second element is an atom, string or integer to be used as the option value atom, string or integer - which will be used as both label and value for the generated select Optgroups If options is map or keyword list where the first element is a string, atom or integer and the second element is a list or a map, it is assumed the key will be wrapped in an &lt;optgroup&gt; and the value will be used to generate &lt;options&gt; nested under the group. Examples # Assuming form contains a User schema select ( form , :age , 0 .. 120 ) #=&gt; &lt;mwc-select id=&quot;user_age&quot; name=&quot;user[age]&quot;&gt; #=&gt; &lt;option value=&quot;0&quot;&gt;0&lt;/option&gt; #=&gt; ... #=&gt; &lt;option value=&quot;120&quot;&gt;120&lt;/option&gt; #=&gt; &lt;/mwc-select&gt; select ( form , :role , [ &quot;Admin&quot; : &quot;admin&quot; , &quot;User&quot; : &quot;user&quot; ] ) #=&gt; &lt;mwc-select id=&quot;user_role&quot; name=&quot;user[role]&quot;&gt; #=&gt; &lt;option value=&quot;admin&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;user&quot;&gt;User&lt;/option&gt; #=&gt; &lt;/mwc-select&gt; select ( form , :role , [ [ key : &quot;Admin&quot; , value : &quot;admin&quot; , disabled : true ] , [ key : &quot;User&quot; , value : &quot;user&quot; ] ] ) #=&gt; &lt;mwc-select id=&quot;user_role&quot; name=&quot;user[role]&quot;&gt; #=&gt; &lt;option value=&quot;admin&quot; disabled=&quot;disabled&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;user&quot;&gt;User&lt;/option&gt; #=&gt; &lt;/mwc-select&gt; You can also pass a prompt: select ( form , :role , [ &quot;Admin&quot; : &quot;admin&quot; , &quot;User&quot; : &quot;user&quot; ] , prompt : &quot;Choose your role&quot; ) #=&gt; &lt;mwc-select id=&quot;user_role&quot; name=&quot;user[role]&quot;&gt; #=&gt; &lt;option value=&quot;&quot;&gt;Choose your role&lt;/option&gt; #=&gt; &lt;option value=&quot;admin&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;user&quot;&gt;User&lt;/option&gt; #=&gt; &lt;/mwc-select&gt; And customize the prompt as any other entry: select ( form , :role , [ &quot;Admin&quot; : &quot;admin&quot; , &quot;User&quot; : &quot;user&quot; ] , prompt : [ key : &quot;Choose your role&quot; , disabled : true ] ) #=&gt; &lt;mwc-select id=&quot;user_role&quot; name=&quot;user[role]&quot;&gt; #=&gt; &lt;option value=&quot;&quot; disabled=&quot;&quot;&gt;Choose your role&lt;/option&gt; #=&gt; &lt;option value=&quot;admin&quot;&gt;Admin&lt;/option&gt; #=&gt; &lt;option value=&quot;user&quot;&gt;User&lt;/option&gt; #=&gt; &lt;/mwc-select&gt; If you want to select an option that comes from the database, such as a manager for a given project, you may write: select ( form , :manager_id , Enum . map ( @managers , &amp; { &amp;1 . name , &amp;1 . id } ) ) #=&gt; &lt;mwc-select id=&quot;manager_id&quot; name=&quot;project[manager_id]&quot;&gt; #=&gt; &lt;option value=&quot;1&quot;&gt;Mary Jane&lt;/option&gt; #=&gt; &lt;option value=&quot;2&quot;&gt;John Doe&lt;/option&gt; #=&gt; &lt;/mwc-select&gt; Finally, if the values are a list or a map, we use the keys for grouping: select ( form , :country , [ &quot;Europe&quot; : [ &quot;UK&quot; , &quot;Sweden&quot; , &quot;France&quot; ] ] , ... ) #=&gt; &lt;mwc-select id=&quot;user_country&quot; name=&quot;user[country]&quot;&gt; #=&gt; &lt;optgroup label=&quot;Europe&quot;&gt; #=&gt; &lt;option&gt;UK&lt;/option&gt; #=&gt; &lt;option&gt;Sweden&lt;/option&gt; #=&gt; &lt;option&gt;France&lt;/option&gt; #=&gt; &lt;/optgroup&gt; #=&gt; ... #=&gt; &lt;/mwc-select&gt; Options :prompt - an option to include at the top of the options. It may be a string or a keyword list of attributes and the :key :selected - the default value to use when none was sent as parameter Be aware that a :multiple option will not generate a correctly functioning multiple select element. Use wc_multiple_select/4 instead. All other options are forwarded to the underlying HTML tag.","ref":"Phoenix.WebComponent.FormHelper.html#wc_select/4","title":"Phoenix.WebComponent.FormHelper.wc_select/4","type":"function"},{"doc":"Generates a wc_submit button to send the form. Examples wc_submit do : &quot;Submit&quot; #=&gt; &lt;button type=&quot;wc_submit&quot;&gt;Submit&lt;/button&gt;","ref":"Phoenix.WebComponent.FormHelper.html#wc_submit/1","title":"Phoenix.WebComponent.FormHelper.wc_submit/1","type":"function"},{"doc":"Generates a wc_submit button to send the form. All options are forwarded to the underlying button tag. When called with a do: block, the button tag options come first. Examples wc_submit &quot;Submit&quot; #=&gt; &lt;button type=&quot;wc_submit&quot;&gt;Submit&lt;/button&gt; wc_submit &quot;Submit&quot; , class : &quot;btn&quot; #=&gt; &lt;button class=&quot;btn&quot; type=&quot;wc_submit&quot;&gt;Submit&lt;/button&gt; wc_submit [ class : &quot;btn&quot; ] , do : &quot;Submit&quot; #=&gt; &lt;button class=&quot;btn&quot; type=&quot;wc_submit&quot;&gt;Submit&lt;/button&gt;","ref":"Phoenix.WebComponent.FormHelper.html#wc_submit/2","title":"Phoenix.WebComponent.FormHelper.wc_submit/2","type":"function"},{"doc":"Generates a telephone input. See text_input/3 for example and docs.","ref":"Phoenix.WebComponent.FormHelper.html#wc_telephone_input/3","title":"Phoenix.WebComponent.FormHelper.wc_telephone_input/3","type":"function"},{"doc":"Generates a text input. The form should either be a Phoenix.WebComponent.Form emitted by form_for or an atom. All given options are forwarded to the underlying input, default values are provided for id, name and value if possible. Examples # Assuming form contains a User schema wc_text_input ( form , :name ) #=&gt; &lt;mwc-textfield id=&quot;user_name&quot; name=&quot;user[name]&quot; type=&quot;text&quot; value=&quot;&quot; /&gt; wc_text_input ( :user , :name ) #=&gt; &lt;mwc-textfield id=&quot;user_name&quot; name=&quot;user[name]&quot; type=&quot;text&quot; value=&quot;&quot; /&gt;","ref":"Phoenix.WebComponent.FormHelper.html#wc_text_input/3","title":"Phoenix.WebComponent.FormHelper.wc_text_input/3","type":"function"},{"doc":"Generates a textarea input. All given options are forwarded to the underlying input, default values are provided for id, name and textarea content if possible. Examples # Assuming form contains a User schema textarea ( form , :description ) #=&gt; &lt;textarea id=&quot;user_description&quot; name=&quot;user[description]&quot;&gt;&lt;/textarea&gt; New lines Notice the generated textarea includes a new line after the opening tag. This is because the HTML spec says new lines after tags must be ignored and all major browser implementations do that. So in order to avoid new lines provided by the user from being ignored when the form is resubmitted, we automatically add a new line before the text area value.","ref":"Phoenix.WebComponent.FormHelper.html#wc_textarea/3","title":"Phoenix.WebComponent.FormHelper.wc_textarea/3","type":"function"},{"doc":"Generates a time input. Warning: this feature isn't available in all browsers. Check http://caniuse.com/#feat=input-datetime for further information. Options :precision - Allowed values: :minute , :second , :millisecond . Defaults to :minute . All other options are forwarded. See text_input/3 for example and docs. Examples wc_time_input form , :time #=&gt; &lt;input id=&quot;form_time&quot; name=&quot;form[time]&quot; type=&quot;time&quot; value=&quot;23:00&quot;&gt; wc_time_input form , :time , precision : :second #=&gt; &lt;input id=&quot;form_time&quot; name=&quot;form[time]&quot; type=&quot;time&quot; value=&quot;23:00:00&quot;&gt; wc_time_input form , :time , precision : :millisecond #=&gt; &lt;input id=&quot;form_time&quot; name=&quot;form[time]&quot; type=&quot;time&quot; value=&quot;23:00:00.000&quot;&gt;","ref":"Phoenix.WebComponent.FormHelper.html#wc_time_input/3","title":"Phoenix.WebComponent.FormHelper.wc_time_input/3","type":"function"},{"doc":"Generates select tags for time. Check wc_datetime_select/3 for more information on options and supported values.","ref":"Phoenix.WebComponent.FormHelper.html#wc_time_select/3","title":"Phoenix.WebComponent.FormHelper.wc_time_select/3","type":"function"},{"doc":"Generates an url input. See text_input/3 for example and docs.","ref":"Phoenix.WebComponent.FormHelper.html#wc_url_input/3","title":"Phoenix.WebComponent.FormHelper.wc_url_input/3","type":"function"},{"doc":"Conveniences for working with links and URLs in HTML.","ref":"Phoenix.WebComponent.Link.html","title":"Phoenix.WebComponent.Link","type":"module"},{"doc":"Generates a button tag that uses the Javascript function handleClick() (see phoenix_html.js) to submit the form data. Useful to ensure that links that change data are not triggered by search engines and other spidering software. Examples button ( &quot;hello&quot; , to : &quot;/world&quot; ) #=&gt; &lt;button class=&quot;button&quot; data-csrf=&quot;csrf_token&quot; data-method=&quot;post&quot; data-to=&quot;/world&quot;&gt;hello&lt;/button&gt; button ( &quot;hello&quot; , to : &quot;/world&quot; , method : :get , class : &quot;btn&quot; ) #=&gt; &lt;button class=&quot;btn&quot; data-method=&quot;get&quot; data-to=&quot;/world&quot;&gt;hello&lt;/button&gt; Options :to - the page to link to. This option is required :method - the method to use with the button. Defaults to :post. All other options are forwarded to the underlying button input. When the :method is set to :get and the :to URL contains query parameters the generated form element will strip the parameters in accordance with the W3C form specification. Data attributes Data attributes are added as a keyword list passed to the data key. The following data attributes are supported: data-confirm - shows a confirmation prompt before generating and submitting the form.","ref":"Phoenix.WebComponent.Link.html#wc_button/2","title":"Phoenix.WebComponent.Link.wc_button/2","type":"function"},{"doc":"Generates a link to the given URL. Examples wc_link ( &quot;hello&quot; , to : &quot;/world&quot; ) #=&gt; &lt;a href=&quot;/world&quot;&gt;&lt;mwc-button&gt;hello&lt;/mwc-button&gt;&lt;/a&gt; wc_link ( &quot;hello&quot; , to : URI . parse ( &quot;https://elixir-lang.org&quot; ) ) #=&gt; &lt;a href=&quot;https://elixir-lang.org&quot;&gt;&lt;mwc-button&gt;hello&lt;/mwc-button&gt;&lt;/a&gt; wc_link ( &quot;&lt;hello&gt;&quot; , to : &quot;/world&quot; ) #=&gt; &lt;a href=&quot;/world&quot;&gt;&lt;mwc-button&gt;&amp;lt;hello&amp;gt;&lt;/mwc-button&gt;&lt;/a&gt; wc_link ( &quot;&lt;hello&gt;&quot; , to : &quot;/world&quot; , class : &quot;btn&quot; ) #=&gt; &lt;a class=&quot;btn&quot; href=&quot;/world&quot;&gt;&lt;mwc-button&gt;&amp;lt;hello&amp;gt;&lt;/mwc-button&gt;&lt;/a&gt; wc_link ( &quot;delete&quot; , to : &quot;/the_world&quot; , data : [ confirm : &quot;Really?&quot; ] ) #=&gt; &lt;a data-confirm=&quot;Really?&quot; href=&quot;/the_world&quot;&gt;&lt;mwc-button&gt;delete&lt;/mwc-button&gt;&lt;/a&gt; # If you supply a method other than `:get`: wc_link ( &quot;delete&quot; , to : &quot;/everything&quot; , method : :delete ) #=&gt; &lt;a href=&quot;/everything&quot; data-csrf=&quot;csrf_token&quot; data-method=&quot;delete&quot; data-to=&quot;/everything&quot;&gt;&lt;mwc-button&gt;delete&lt;/mwc-button&gt;&lt;/a&gt; # You can use a `do ... end` block too: link to : &quot;/hello&quot; do &quot;world&quot; end #=&gt; &lt;a href=&quot;/hello&quot;&gt;&lt;mwc-button&gt;world&lt;/mwc-button&gt;&lt;a&gt; Options :to - the page to link to. This option is required :method - the method to use with the link. In case the method is not :get , the link is generated inside the form which sets the proper information. In order to submit the form, JavaScript must be enabled :csrf_token - a custom token to use for links with a method other than :get . All other options are forwarded to the underlying &lt;a&gt; tag. Data attributes Data attributes are added as a keyword list passed to the data key. The following data attributes are supported: data-confirm - shows a confirmation prompt before generating and submitting the form when :method is not :get . CSRF Protection By default, CSRF tokens are generated through Plug.CSRFProtection .","ref":"Phoenix.WebComponent.Link.html#wc_link/2","title":"Phoenix.WebComponent.Link.wc_link/2","type":"function"},{"doc":"Generates a link that will patch the current LiveView. When navigating to the current LiveView, Phoenix.LiveView.handle_params/3 is immediately invoked to handle the change of params and URL state. Then the new state is pushed to the client, without reloading the whole page while also maintaining the current scroll position. For live redirects to another LiveView, use wc_live_redirect/2 . Options :to - the required path to link to. :replace - the flag to replace the current history or push a new state. Defaults false . All other options are forwarded to the anchor tag. Examples &lt;%= wc_live_patch &quot;home&quot;, to: Routes.page_path(@socket, :index) %&gt; &lt;%= wc_live_patch &quot;next&quot;, to: Routes.live_path(@socket, MyLive, @page + 1) %&gt; &lt;%= wc_live_patch to: Routes.live_path(@socket, MyLive, dir: :asc), replace: false do %&gt; Sort By Price &lt;% end %&gt;","ref":"Phoenix.WebComponent.Link.html#wc_live_patch/2","title":"Phoenix.WebComponent.Link.wc_live_patch/2","type":"function"},{"doc":"Generates a link that will redirect to a new LiveView of the same live session. The current LiveView will be shut down and a new one will be mounted in its place, without reloading the whole page. This can also be used to remount the same LiveView, in case you want to start fresh. If you want to navigate to the same LiveView without remounting it, use wc_live_patch/2 instead. Note : The live redirects are only supported between two LiveViews defined under the same live session. See Phoenix.LiveView.Router.live_session/3 for more details. Options :to - the required path to link to. :replace - the flag to replace the current history or push a new state. Defaults false . All other options are forwarded to the anchor tag. Examples &lt;%= wc_live_redirect &quot;home&quot;, to: Routes.page_path(@socket, :index) %&gt; &lt;%= wc_live_redirect &quot;next&quot;, to: Routes.live_path(@socket, MyLive, @page + 1) %&gt; &lt;%= wc_live_redirect to: Routes.live_path(@socket, MyLive, dir: :asc), replace: false do %&gt; Sort By Price &lt;% end %&gt;","ref":"Phoenix.WebComponent.Link.html#wc_live_redirect/2","title":"Phoenix.WebComponent.Link.wc_live_redirect/2","type":"function"},{"doc":"Render markdown in to remark-element. The remark-element supported markdown featrues: github flavor auto highlight code with lowlight.js and auto detect system light/dark themes. charts render by mermaid.js","ref":"Phoenix.WebComponent.Markdown.html","title":"Phoenix.WebComponent.Markdown","type":"module"},{"doc":"","ref":"Phoenix.WebComponent.Markdown.html#wc_remark/1","title":"Phoenix.WebComponent.Markdown.wc_remark/1","type":"function"},{"doc":"Generates a html customElement remark-element to preview markdown. Docs of remark-element (See https://gsmlg-dev.github.io/lit/?path=/story/gsmlg-remark-element--basic). Useful to ensure that links that change data are not triggered by search engines and other spidering software. Examples wc_remark ( &quot;# Hello&quot; , class : &quot;dark&quot; ) #=&gt; &lt;remark-element class=&quot;dark&quot; content=&quot;# Hello&quot;&gt;&lt;/remark-element&gt; wc_remark ( content : &quot;# Hello&quot; , class : &quot;btn&quot; ) #=&gt; &lt;remark-element class=&quot;btn&quot; content=&quot;# Hello&quot;&gt;&lt;/remark-element&gt; Options :debug - print log in browser console :content - The content of markdown, replace innerHTML. All other options are forwarded to the underlying button input.","ref":"Phoenix.WebComponent.Markdown.html#wc_remark/2","title":"Phoenix.WebComponent.Markdown.wc_remark/2","type":"function"},{"doc":"Bug Fixes Avoid warning about jason. ( 03182c3 ) Features Add pattern to validte email input. ( 1f33349 ) First release. ( #1 ) ( 3294354 ) Initital package. ( 090475d ) 1.0.0 (2022-04-16) Bug Fixes Avoid warning about jason. ( 03182c3 ) Features Add pattern to validte email input. ( 1f33349 ) First release. ( #1 ) ( 3294354 ) Initital package. ( 090475d ) 1.0.0 (2022-04-16) Bug Fixes Avoid warning about jason. ( 03182c3 ) Features Add pattern to validte email input. ( 1f33349 ) First release. ( #1 ) ( 3294354 ) Initital package. ( 090475d ) 1.0.0 (2022-04-16) Bug Fixes Avoid warning about jason. ( 03182c3 ) Features First release. ( #1 ) ( 3294354 ) Initital package. ( 090475d ) 1.0.0 (2022-04-16) Features First release. ( #1 ) ( 3294354 ) Initital package. ( 090475d ) 1.0.0-beta.4 (2022-04-16) Bug Fixes Fix data-confirm. ( 3b14108 ) Optimize link. ( 8686596 ) Features Add live view link helper, wc_live_patch , wc_live_redirect . ( 323347f ) 1.0.0-beta.3 (2022-04-16) Bug Fixes Fix docs. ( b0806ca ) 1.0.0-beta.2 (2022-04-16) Bug Fixes Fix publish. ( 31787ce ) Fix test. ( 9bd953a ) Features Bundle js. ( f5cf9cd ) 1.0.0-beta.2 (2022-04-16) Bug Fixes Fix test. ( 9bd953a ) Features Bundle js. ( f5cf9cd ) 1.0.0-beta.1 (2022-04-16) Bug Fixes Finish test. ( 7a72801 ) Fix errors. ( eb15385 ) Fix import. ( 4277eaf ) Fix issue. ( 3523dc9 ) Fix link_attributes. ( 9d55077 ) Format code. ( 7a37b11 ) Optimize password. ( f763731 ) Features Add wc_remark . ( 9714a45 ) Add phoenix_html to deps. ( d8ea8a4 ) Initital package. ( 090475d ) Into beta, optimize input, start make it more reliable and more useful. ( adf4133 ) Set web compoent form. ( ba3bf68 ) 1.0.0-alpha.2 (2022-04-16) Features Add wc_remark . ( 9714a45 ) 1.0.0-alpha.1 (2022-04-15) Bug Fixes Finish test. ( 7a72801 ) Fix import. ( 4277eaf ) Fix link_attributes. ( 9d55077 ) Format code. ( 7a37b11 ) Features Add phoenix_html to deps. ( d8ea8a4 ) Initital package. ( 090475d ) Set web compoent form. ( ba3bf68 ) Changelog","ref":"changelog.html","title":"1.0.0 (2022-04-16)","type":"extras"}]